/*********************************************************************
 * ArgPerse.h
 *     R}hC̓wb_[
 * @\
 *         Win32  R}hCAȂ킿 GetCommandLine() API ̒l
 *         ͂AC  main ֐ɂ argc / argv ̔zɕ
 *         B
 *         NX cls_ArgPerse @\񋟁B
 * gp@
 *      1. #include "ArgPerse.h"
 *      2. cls_ArgPerse  Arg;
 *      3. Arg.C ɂăR}hC̐擾B
 *      4. Arg.V[Index] ɂĎۂ̃R}hCl擾B
 * ӓ_
 *      1. Index ͈̔͂́A(0) ` (Arg.C - 1)B
 *         Arg.C  0 Ăꍇ́AArg.V ɃANZX̓
 *         ۏ؂ȂB
 *      2. Arg.V[0]  GetCommandLine() ̎dlɂANꂽvO
 *         ̃pXi[ĂB
 *      3. argc / argv ƓlA" ň͂܂ꂽ " 菜B
 *         " ň͂܂ꂽ͈͂ł́A\"  " ɁA\\  \ ɒuB
 *      4. argc / argv ƈقȂ_ƂāA/ ̋؂ƂĈB
 *         ܂AR}hC "/A/B" ^ꂽA
 *             argc / argv   F "/A/B"     i 1 j
 *             ̃W[F "/A" "/B"  i 2 j
 *         ƂȂB
 *      5. Arg.C  Arg.V ̓éAp҂̐ӔCŕҏW\B
 *         ̏ꍇɂ͂ANXƂĂ͘_Iɋ@\ȂȂ
 *         A argc / argv ҏWꍇƓȂ̂ōlĂ
 *         ȂB
 *         ̈ӂɕҏWꍇɁAҏWÕobNAbv~́A
 *         NXcls_ArgPerse ̃CX^XB
 * Tv
 *         #include  "ArgPerse.h"
 *         int APIENTRY WinMain(HINSTANCE hInstance,
 *                              HINSTANCE hPrevInstance,
 *                              LPSTR     lpCmdLine,
 *                              int       nCmdShow)
 *         {
 *             cls_ArgPerse  Arg;
 *             char          buf[10240];
 *             size_t        bufpos = wsprintf(buf, 
 *                 "F\n"
 *                 "%s\n"
 *                 "\n"
 *                 "̐F\n"
 *                 "%d",
 *                 GetCommandLine(), Arg.C);
 *             for(int  i = 0; i < Arg.C; i++)
 *             {
 *                 bufpos += wsprintf(&buf[bufpos],
 *                     "\n"
 *                     "\n"
 *                     " %d F\n"
 *                     "%s",
 *                     i + 1, Arg.V[i]);
 *             }
 *             MessageBox(NULL, buf, "Test", MB_OK);
 *             return 0;
 *         }
 * 
 *      1. F 2000 N 9  6 
 *         ҎҁF "ĂƁ" <tategoto@harpy.jp>
 *         eF VK쐬
 *      2. F 2000 N 9  13 
 *         ҎҁF "ĂƁ" <tategoto@harpy.jp>
 *         eF wb_[ƃ\[X 2 t@Cɕ
 *                錾ς݃O[oCX^X Arg ̔p~
 *      3. F 2011 N 2  16 
 *         ҎҁF "ĂƁ" <tategoto@harpy.jp>
 *         eF R}hCɃXy[Xꍇ]vȋ
 *                ێȂ悤C
 *********************************************************************/

#ifndef  _INC_ARGPERSE_
#define  _INC_ARGPERSE_

#ifndef  _WINDOWS_
#error ArgPerse.h must be included after windows.h.
#endif

#ifndef  WIN32
#error   cls_ArgPerse (ArgPerse.cpp) must be compiled in WIN32.
#endif


class  cls_ArgPerse
{
	public:
		cls_ArgPerse();
		~cls_ArgPerse();

	public:
		int     C;
		LPSTR   *V;

	private:
		LPSTR   mBuf;
		HANDLE  mHeap;

};

#endif  //_INC_ARGPERSE
