/*********************************************************************
 * TpNumPad.cpp
 *     TpNumPad eLXg̐̌
 * Author
 *     "ĂƁ" <tategoto@harpy.jp>
 * Version
 *     0.03
 * Updated
 *     2012/01/15
 *********************************************************************/


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// wb_[CN[h ////////////

#include <windows.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "resource.h"

#include "ArgPerse.h"
#include "cTeraPad.h"
#include "WinUtil.h"


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// \̒` ////////////

struct  st_Option  // IvVi[\
{
	bool   D_ShowDialog;    // true Ȃ_CAOŃIvVݒmF

	bool   O_ProcessOnlySelected;     // gp - true ȂI͈͂̂ݏAłȂΑS

	bool   Z_PaddingZero;   // [ŌȂ trueAXy[XŒȂ false
	DWORD  L_LowestCipher;  // Œጅ
}	Option;


//////////// 萔` ////////////

#define  MY_NAME                  "TpNumPad"       // MessageBox ̃^CgɎgp閼O

#define  INI_SECTION_OPTION       "Option"         // ݒt@C̃IvVZNV̖O
#define  INI_KEY_PADDINGZERO      "PaddingZero"    // ݒt@C̍ - [ŌȂ 1AXy[XŒȂ 0
#define  INI_KEY_LOWESTCIPHER     "LowestCipher"   // ݒt@C̍ - [ŌȂ 1AXy[XŒȂ 0

#define  LIMIT_SIZE_SAFE_PROCESS            32760  // EBhEbZ[WoRŃf[^󂯓nɕۏ؂łő̃f[^TCY
#define  BUF_SIZE_FOR_MESSAGEBOX             4096  // MessageBox ҏWpobt@̃TCY
#define  BLOCK_UNIT_FOR_POINTERS             4096  // s|C^̈̈xɊmۂubNTCY
#define  MARGIN_SIZE                          256  // rŎgobt@֗]ɊmۂoCg
#define  MIN_DWORD                              1  // ňŏ̕
#define  MAX_DWORD                     0x7FFFFFFF  // ňő̕

#define  MSECOND_ANIMATEMWINDOW               120  // EBhEXCh\ (~b)

#define  _                                         // (;_;)

#define  for                      if(0); else for  // VC6 ̂܂Ȃ


//////////// CNXvg^Cv ////////////

// TpNumPad {
class  cls_TpNumPad
{
	public:
		char          MessageBuf[BUF_SIZE_FOR_MESSAGEBOX];  // MessageBox ҏWpobt@
		cls_TeraPad   TeraPad;                              // TeraPad Rg[
		cls_ArgPerse  Arg;                                  // R}hC

	public:
		bool                  GetOptionFromArguments();                                                        // R}hCIvV擾
		void                  ShowArgumentError(int ErrorPos);                                                 // G[ꍇɃbZ[W\Ēf
		int                   GetOptionFromDialog(HINSTANCE hInstance);                                        // IvV_CAO̕\
		friend BOOL CALLBACK  cls_TpNumPad_DialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);  // IvV_CAÕEChEvV[W iR[obNj
		BOOL                  DialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);               // IvV_CAÕEChEvV[W
		LPSTR                 GetTextFromTeraPad();                                                            // TeraPad eLXg擾
		bool                  ProcessString(LPSTR &sText);                                                     // eLXg\[g
		void                  SetTextToTeraPad(LPSTR sText);                                                   // TeraPad փeLXgݒ
};


//////////// Tu[`vg^Cv ////////////

bool  StrToDWORD(DWORD &dest, LPSTR src);  // ǂݐlɕϊAG[ false Ԃ
bool  IsDigit(char ch);                    // w̕ '0' ` '9' Ȃ true


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// C ////////////

int APIENTRY  WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
#ifdef  _DEBUG
	SetForegroundWindowSure(FindWindow(TERAPAD_CLASS_MAINFORM, NULL));
#endif
	//////////// Ăяo TeraPad ̕ߑ ////////////
	// B TpNumPad IuWFNg쐬
	cls_TpNumPad  TpNumPad;
	// TeraPad ߂܂ꂽǂ̊mF - sP
	if(!TpNumPad.TeraPad)
	{
		MessageBox(TpNumPad.TeraPad.hWin, "TeraPad ̕ߑɎs܂B", MY_NAME, MB_OK | MB_ICONERROR);
		return -1;
	}

	
	//////////// IvV̌ ////////////
	// IvVR}hC擾
	if(!TpNumPad.GetOptionFromArguments())
		return -2;
	// Kv΃IvV_CAO
	if(Option.D_ShowDialog && TpNumPad.GetOptionFromDialog(hInstance) == IDCANCEL)
		return -3;

	//////////// TeraPad f[^擾 ////////////
	// ҏWeLXg擾
	LPSTR  sText = TpNumPad.GetTextFromTeraPad();
	if(sText == NULL)
	{
		MessageBox(TpNumPad.TeraPad.hWin, "eLXg̎擾Ɏs܂B", MY_NAME, MB_OK | MB_ICONERROR);
		return -4;
	}


	//////////// eLXg\[g ////////////
	if(!TpNumPad.ProcessString(sText))
		return -5;


	//////////// TeraPad փf[^Ԃ ////////////
	TpNumPad.SetTextToTeraPad(sText);


	//////////// M ////////////
	MessageBeep(MB_OK);
	return 0;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// CNX ////////////

// R}hCIvV擾
bool  cls_TpNumPad::GetOptionFromArguments()
{
	// IvVlݒ
	Option.D_ShowDialog   = false;

	Option.Z_PaddingZero  = true;
	Option.L_LowestCipher = 1;

	// R}hCIvV擾
	bool   ArgumentExisting = false;
	bool   ErrorOccured     = false;
	DWORD  dwCol;
	for(int  iIndex = 1; iIndex < Arg.C; iIndex++)
	{
		if(Arg.V[iIndex][0] == '\0')
			continue;
		ArgumentExisting = true;
		if(Arg.V[iIndex][0] != '/' || Arg.V[iIndex][1] == '\0')
		{
			ShowArgumentError(iIndex);
			ErrorOccured = true;
		}
		else if(Arg.V[iIndex][2] == ':')
		{
			switch(Arg.V[iIndex][1])
			{
				case 'L':
				case 'l':
					if(StrToDWORD(Option.L_LowestCipher, &Arg.V[iIndex][3]))
						break;
					// fall through

				default:
					ShowArgumentError(iIndex);
					ErrorOccured = true;
					break;
			}
		}
		else for(dwCol = 1; Arg.V[iIndex][dwCol] != '\0'; dwCol++)
		{
			switch(Arg.V[iIndex][dwCol])
			{
				case 'D': Option.D_ShowDialog  = true ; break;
				case 'd': Option.D_ShowDialog  = false; break;

				case 'Z': Option.Z_PaddingZero = true ; break;
				case 'z': Option.Z_PaddingZero = false; break;

				default:
					ShowArgumentError(iIndex);
					ErrorOccured = true;
					break;
			}
		}
	}

	if(!ArgumentExisting || ErrorOccured)
		Option.D_ShowDialog = true;

	return true;
}


////////////////////////////////////////////////////////////////////////////////

// G[ꍇɃbZ[W\Ēf
void  cls_TpNumPad::ShowArgumentError(int ErrorPos)
{
	wsprintf(MessageBuf, "%d Ԗڂ̈Fł܂F '%s'", ErrorPos, Arg.V[ErrorPos]);
	MessageBox(TeraPad.hWin, MessageBuf, MY_NAME, MB_OK | MB_ICONERROR);
}


////////////////////////////////////////////////////////////////////////////////

// IvV_CAO̕\
int  cls_TpNumPad::GetOptionFromDialog(HINSTANCE hInstance)
{
	int  Result = DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_Option), TeraPad.hWin, cls_TpNumPad_DialogProc, (LPARAM)this);
	if(Result == -1)
	{
		MessageBox(TeraPad.hWin, "_CAŐNɎs܂B", MY_NAME, MB_OK | MB_ICONINFORMATION);
		return IDCANCEL;
	}

	return Result;
}


////////////////////////////////////////////////////////////////////////////////

// IvV_CAÕEChEvV[W iR[obNj
BOOL CALLBACK  cls_TpNumPad_DialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static cls_TpNumPad  *TpNumPad;
	if(uMsg == WM_INITDIALOG)
		TpNumPad = (cls_TpNumPad *)lParam;

	int  DialogResult = TpNumPad->DialogProc(hWndDlg, uMsg, wParam, lParam);
	if(DialogResult == IDOK || DialogResult == IDCANCEL)
		EndDialog(hWndDlg, DialogResult);

	return FALSE;
}


////////////////////////////////////////////////////////////////////////////////

// IvV_CAÕEChEvV[W ij
int  cls_TpNumPad::DialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static char  IniFile[MAX_PATH];

	switch(uMsg)
	{
		/////////// _CAO ///////////
		case WM_INITDIALOG:
			SetClassLong(hWndDlg, GCL_HICON, (LONG)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_ICON1)));
			CenteringWindow(hWndDlg, TeraPad.hWin);

			GetModuleFileName(GetModuleHandle(NULL), IniFile, sizeof(IniFile));
			memcpy(&IniFile[strlen(IniFile) - 3], "ini", 4);

			Option.Z_PaddingZero  = GetPrivateProfileInt(INI_SECTION_OPTION, INI_KEY_PADDINGZERO , Option.Z_PaddingZero? 1: 0, IniFile) != 0;
			Option.L_LowestCipher = GetPrivateProfileInt(INI_SECTION_OPTION, INI_KEY_LOWESTCIPHER, Option.L_LowestCipher     , IniFile);

			CheckDlgButton(hWndDlg, Option.Z_PaddingZero? IDC_RADIO1_PadZero: IDC_RADIO1_PadSpace, BST_CHECKED);
			SetDlgItemInt( hWndDlg, IDC_EDIT_LowestCipher, Option.L_LowestCipher, FALSE);

			break;

		/////////// EBhE\ ///////////
		case WM_SHOWWINDOW:
			AnimateWindow(hWndDlg, MSECOND_ANIMATEMWINDOW, AW_ACTIVATE | AW_CENTER);
			break;

		/////////// [U[Cxg ///////////
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				// OK {^NbN
				case IDOK:
					if(IsDlgButtonChecked(hWndDlg, IDC_RADIO1_PadZero) == BST_CHECKED)
						Option.Z_PaddingZero = true;
					else if(IsDlgButtonChecked(hWndDlg, IDC_RADIO1_PadSpace) == BST_CHECKED)
						Option.Z_PaddingZero = false;
					else
					{
						MessageBox(TeraPad.hWin, "u̒Ɏgv w肵ĂB", MY_NAME, MB_OK | MB_ICONINFORMATION);
						break;
					}
					BOOL  bRet;
					Option.L_LowestCipher = GetDlgItemInt(hWndDlg, IDC_EDIT_LowestCipher, &bRet, FALSE);
					if(bRet == FALSE || Option.L_LowestCipher < MIN_DWORD || Option.L_LowestCipher > MAX_DWORD)
					{
						wsprintf(MessageBuf, "Œጅ %u ` %u ̐Ŏw肵ĂB", MIN_DWORD, MAX_DWORD);
						MessageBox(TeraPad.hWin, MessageBuf, MY_NAME, MB_OK | MB_ICONINFORMATION);
						break;
					}

					WritePrivateProfileString(INI_SECTION_OPTION, INI_KEY_PADDINGZERO , Option.Z_PaddingZero? "1": "0", IniFile);
					wsprintf(MessageBuf, "%u", Option.L_LowestCipher);
					WritePrivateProfileString(INI_SECTION_OPTION, INI_KEY_LOWESTCIPHER, MessageBuf                    , IniFile);

					AnimateWindow(hWndDlg, MSECOND_ANIMATEMWINDOW, AW_HIDE | AW_CENTER);
					return IDOK;

				// LZ{^NbN
				case IDCANCEL:
					SendMessage(hWndDlg, WM_CLOSE, (WPARAM)NULL, (LPARAM)NULL);
					break;
			}
			break;

		/////////// I{^NbN ///////////
		case WM_CLOSE:
			AnimateWindow(hWndDlg, MSECOND_ANIMATEMWINDOW, AW_HIDE | AW_CENTER);
			return IDCANCEL;
			break;
	}
	return 0;
}


////////////////////////////////////////////////////////////////////////////////

// TeraPad eLXg擾
LPSTR  cls_TpNumPad::GetTextFromTeraPad()
{
	Option.O_ProcessOnlySelected = (TeraPad.GetSelMode() != TpSelMode_None);

	if(Option.O_ProcessOnlySelected)
		return TeraPad.GetSelText();
	return TeraPad.GetText();
}


////////////////////////////////////////////////////////////////////////////////

// ̌
bool  cls_TpNumPad::ProcessString(LPSTR &sText)
{
	// Uǂŏʂ̃TCY߂
	const DWORD  dwLen = lstrlen(sText);
	DWORD        dwTotalSize = 0, dwNumCnt = 0;
	for(DWORD  i = 0; i < dwLen; ++i)
	{
		DWORD  dwNum = i, dwPos = i;
		while(IsDigit(sText[i]))
			++i;
		dwNum = i - dwNum;
		if(dwNum)
		{
			while(sText[dwPos] == '0')
			{
				--dwNum;
				++dwPos;
			}
			if(Option.L_LowestCipher < dwNum)
				Option.L_LowestCipher = dwNum;
			++dwNumCnt;
		}
		if(sText[i] != '\0')
			++dwTotalSize;
	}
	dwTotalSize += Option.L_LowestCipher * dwNumCnt;

	// ݗpobt@̗p
	LPSTR  buf = sText;
	sText = (LPSTR)HeapAlloc(TeraPad.hHeap, HEAP_NO_SERIALIZE, dwTotalSize + 1);
	if(!sText)
	{
		sText = buf;
		return false;
	}

	// Jn
	const char  chPad = Option.Z_PaddingZero? '0': ' ';
	LPSTR       dest = sText;
	for(DWORD  i = 0; i < dwLen; ++i)
	{
		DWORD  dwPos = i;
		while(IsDigit(buf[i]))
			++i;
		DWORD  dwNum = i - dwPos;
		if(!dwNum)
		{
			*dest++ = buf[i];
			continue;
		}
		while(buf[dwPos] == '0')
		{
			--dwNum;
			++dwPos;
		}
		if(dwPos == i)
		{
			FillMemory(dest, Option.L_LowestCipher - 1, chPad);
			dest += Option.L_LowestCipher - 1;
			*dest++ = '0';
			--i;
			continue;
		}
		DWORD  j, dwDiff = Option.L_LowestCipher - dwNum;
		dwNum += dwDiff
			;
		for(j = 0; j < dwDiff; ++j)
			*dest++ = chPad;
		--i;
		bool  nohit = true;
		for(j = dwPos; j <= i; ++j)
		{
			if(!Option.Z_PaddingZero && nohit && j < i && IsDigit(buf[j]))
			{
				if(buf[j] == '0')
				{
					*dest++ = ' ';
					continue;
				}
				nohit = false;
			}
			*dest++ = buf[j];
		}
	}
	*dest = '\0';

	//////////// M ////////////
	HeapFree(TeraPad.hHeap, HEAP_NO_SERIALIZE, buf);
	return true;
}


////////////////////////////////////////////////////////////////////////////////

// TeraPad փeLXgݒ
void  cls_TpNumPad::SetTextToTeraPad(LPSTR sText)
{
	//////////// \[gʂ̏߂ ////////////
	if(Option.O_ProcessOnlySelected)
		TeraPad.SetSelText(sText);
	else
	{
		TeraPad.SetText(sText);
		TeraPad.SetSelStart(0);
	}
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// Tu[`` ////////////

// ǂݐlɕϊAG[ false Ԃ
bool  StrToDWORD(DWORD &dest, LPSTR src)
{
	LPSTR  lastpos = &src[strlen(src)];
	if(!lastpos)
		return false;

	LPSTR  readpos;
	DWORD  ret = strtoul(src, &readpos, 10);
	if(lastpos != readpos)
		return false;

	if(ret < MIN_DWORD || ret > MAX_DWORD)
		return false;
	dest = ret;
	return true;
}


////////////////////////////////////////////////////////////////////////////////

// w̕ '0' ` '9' Ȃ true
bool  IsDigit(char ch)
{
	return ch >= '0' && ch <= '9';
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
