/*********************************************************************
 * WinUtil.cpp
 *     Windows	T|[g[`
 * Author
 *     "ĂƁ" <tategoto@harpy.org>
 * Updated
 *     2002/02/06
 *********************************************************************/


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// wb_[CN[h ////////////

#include  "WinUtil.h"
#include  <tlhelp32.h>


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// T|[g[` ////////////

// EBhEɑ΂ăL[
void  KeyDownWindow(HWND hWnd, int KeyCode, unsigned short KeyNum)
{
	SendMessage(hWnd, WM_KEYDOWN, (WPARAM)KeyCode, (LPARAM)KeyNum);
}


//////////////////////////////////////////////////////////////////////

// EBhEɑ΂ăL[
void  KeyUpWindow(HWND hWnd, int KeyCode, unsigned short KeyNum)
{
	SendMessage(hWnd, WM_KEYUP, (WPARAM)KeyCode, (LPARAM)KeyNum);
}


//////////////////////////////////////////////////////////////////////

// EBhEɑ΂ăL[ 1 ĕ
void  KeyPressWindow(HWND hWnd, int KeyCode, int KeyNum)
{
	int  i;
	for(i = 0; i < KeyNum; i++)
	{
		KeyDownWindow(hWnd, KeyCode);
		KeyUpWindow(hWnd, KeyCode);
	}
}


//////////////////////////////////////////////////////////////////////

// mɃEBhEANeBuɂ
void  SetActiveWindowSure(HWND hWnd)
{
	SendMessage(hWnd, WM_ACTIVATE, (WPARAM)WA_CLICKACTIVE, (LPARAM)NULL);
}


//////////////////////////////////////////////////////////////////////

//mɑOiEBhEݒ肷
#ifndef  SPI_GETFOREGROUNDLOCKTIMEOUT
#define  SPI_GETFOREGROUNDLOCKTIMEOUT  0x2000
#define  SPI_SETFOREGROUNDLOCKTIMEOUT  0x2001
#endif
BOOL  SetForegroundWindowSure(HWND hWnd)
{
	// NULL Ԃ
	if(hWnd == NULL)
		return SetForegroundWindow(NULL);
	// [U[͌ɃAvP[V؂ւ֎~鎞 (ȉ u֎~ԁv) 擾
	DWORD  dwWindowChangeTime = 0;
	SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, NULL, &dwWindowChangeTime, NULL);
	// ֎~Ԃ 0 ɐݒ
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, NULL, (LPVOID)NULL, NULL);
	// w̃EBhEANeBu
	BOOL  RetCode = SetForegroundWindow(hWnd);
	// ֎~Ԃɖ߂
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, NULL, (LPVOID)dwWindowChangeTime, NULL);
	// M
	return RetCode;
}


////////////////////////////////////////////////////////////////////////////////

// eEBhEɍ킹ăZ^Os
void  CenteringWindow(HWND hWnd, HWND hWndParent, BOOL UpCenter)
{
	// ̃EBhEʒu擾
	RECT  OwnRect;
	GetWindowRect(hWnd, &OwnRect);
	// ẽEBhEʒu擾
	RECT  TargetRect;
	if(hWndParent == NULL)
		SystemParametersInfo(SPI_GETWORKAREA, NULL, &TargetRect, 0);
	else
		GetWindowRect(hWndParent, &TargetRect);
	// ĔzuʒǔvZ
	int  Width  = OwnRect.right  - OwnRect.left;
	int  Height = OwnRect.bottom - OwnRect.top;
	int  X      = (TargetRect.right  - TargetRect.left - Width ) / 2                 + TargetRect.left;
	int  Y      = (TargetRect.bottom - TargetRect.top  - Height) / (UpCenter ? 3: 2) + TargetRect.top;
	MoveWindow(hWnd, X, Y, Width, Height, FALSE);
}


////////////////////////////////////////////////////////////////////////////////

// EBhẼXCh\
#ifndef  WINUTIL_NO_ANIMATEWINDOW
BOOL  AnimateWindow(HWND hWnd, DWORD dwTime, DWORD dwFlags)
{
	typedef  BOOL  (WINAPI *Func_AnimateWindow_Proc)(HWND hWnd, DWORD dwTime, DWORD dwFlags);

	Func_AnimateWindow_Proc My_AnimateWindow_Proc = (Func_AnimateWindow_Proc)GetProcAddress(GetModuleHandle("user32"), "AnimateWindow");
	if(My_AnimateWindow_Proc == NULL)
		return FALSE;
	return My_AnimateWindow_Proc(hWnd, dwTime, dwFlags);
}
#endif// WINUTIL_NO_ANIMATEWINDOW


////////////////////////////////////////////////////////////////////////////////

// EBhEnhɊ֘AtꂽvZX̋Nt@C擾
BOOL  GetWindowModuleName(HWND hWnd, LPSTR lpBuf, DWORD dwBufSize)
{
	//////////// NULL Ԃ ////////////
	if(!IsWindow(hWnd) || lpBuf == NULL || dwBufSize < 1)
		return FALSE;

	//////////// API Gg̏ ////////////
	typedef  HANDLE  (WINAPI *Func_CreateToolhelp32Snapshot)(DWORD dwFlags, DWORD th32ProcessID);
	typedef  BOOL    (WINAPI *Func_Process32First          )(HANDLE hSnapshot, LPPROCESSENTRY32 lpPE32);
	typedef  BOOL    (WINAPI *Func_Process32Next           )(HANDLE hSnapshot, LPPROCESSENTRY32 lpPE32);
	typedef  BOOL    (WINAPI *Func_EnumProcessModules      )(HANDLE hProcess, HMODULE *lphModule, DWORD cb, LPDWORD lpcbNeeded);
	typedef  DWORD   (WINAPI *Func_GetModuleFileNameEx     )(HANDLE hProcess, HMODULE hModule, LPTSTR lpFilename, DWORD nSize);
	static Func_CreateToolhelp32Snapshot  My_CreateToolhelp32Snapshot = NULL;
	static Func_Process32First            My_Process32First           = NULL;
	static Func_Process32Next             My_Process32Next            = NULL;
	static Func_EnumProcessModules        My_EnumProcessModules       = NULL;
	static Func_GetModuleFileNameEx       My_GetModuleFileNameEx      = NULL;
	static BOOL  UseToolhelp32        = TRUE;
	static BOOL  APIEntry_Initialized = FALSE;
	if(!APIEntry_Initialized)
	{
		// OS  NT Ȃ PSAPI AłȂȂ ToolHelp32  API Gg
		// Windows 2000 āAToolhelp32 ɑΉ̂ƎvAW[tpXŎ擾łȂAr[ ()
		OSVERSIONINFO  OSVersionInfo;
		OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVersionInfo);
		GetVersionEx(&OSVersionInfo);
		UseToolhelp32 = (OSVersionInfo.dwPlatformId != VER_PLATFORM_WIN32_NT);
		if(UseToolhelp32)
		{
			// ToolHelp32 ̃Gg
			HMODULE  hModuleKernel32 = GetModuleHandle("kernel32");
			My_CreateToolhelp32Snapshot = (Func_CreateToolhelp32Snapshot)GetProcAddress(hModuleKernel32, "CreateToolhelp32Snapshot");
			My_Process32First           = (Func_Process32First          )GetProcAddress(hModuleKernel32, "Process32First"          );
			My_Process32Next            = (Func_Process32Next           )GetProcAddress(hModuleKernel32, "Process32Next"           );
			// Gg 1 łsP
			if(My_CreateToolhelp32Snapshot == NULL || My_Process32First == NULL || My_Process32Next == NULL)
				return FALSE;
			APIEntry_Initialized = TRUE;
		}
		else
		{
			// PSAPI ̃Gg
			HMODULE  hModulePSAPI = GetModuleHandle("psapi");
			if(hModulePSAPI == NULL)
				hModulePSAPI = LoadLibrary("psapi");
			My_EnumProcessModules  = (Func_EnumProcessModules )GetProcAddress(hModulePSAPI, "EnumProcessModules"  );
			My_GetModuleFileNameEx = (Func_GetModuleFileNameEx)GetProcAddress(hModulePSAPI, "GetModuleFileNameExA");
			// Gg 1 łsP
			if(My_EnumProcessModules == NULL || My_GetModuleFileNameEx == NULL)
				return FALSE;
			APIEntry_Initialized = TRUE;
		}
	}

	//////////// Nt@C擾 ////////////
	BOOL   RetState = FALSE;
	// ^[Qbg̃vZX ID 擾
	DWORD  TargetProcessID;
	GetWindowThreadProcessId(hWnd, &TargetProcessID);

	// ToolHelp32 ܂ PSAPI Ă
	if(UseToolhelp32)
	{
		// vZXXg̃XibvVbĝ - sP
		HANDLE  hSnapshot = My_CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);
		if(hSnapshot == (HANDLE)-1)
			return FALSE;
		// XibvVbg̍ŏ
		PROCESSENTRY32  PE32;
		PE32.dwSize = sizeof(PROCESSENTRY32);
		BOOL  Result = My_Process32First(hSnapshot, &PE32);
		// XibvVbgSĉ܂Ń[v
		while(Result != FALSE)
		{
			// vZX ID vt@CRs[ĊMA[v𔲂
			if(PE32.th32ProcessID == TargetProcessID)
			{
				strncpy(lpBuf, PE32.szExeFile, dwBufSize);
				RetState = TRUE;
				break;
			}
			// XibvVbg̎
			PE32.dwSize = sizeof(PROCESSENTRY32);
			Result = My_Process32Next(hSnapshot, &PE32);
		}
		// vZXXg̃XibvVbg
		CloseHandle(hSnapshot);
	}
	else
	{
		// vZX߂܂ - sP
		HANDLE  hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, TargetProcessID);
		if(hProcess == NULL)
			return FALSE;
		// vZX̋NW[nh𒲂ׂ
		HMODULE  hModule;
		DWORD    cbReturned;
		if(My_EnumProcessModules(hProcess, &hModule, sizeof(hModule), &cbReturned) != FALSE)
		{
			// t@C̎擾 - M
			if(My_GetModuleFileNameEx(hProcess, hModule, lpBuf, dwBufSize))
				RetState = TRUE;
		}
		// ߂܂vZX
		CloseHandle(hProcess);
	}

	//////////// M܂͓P ////////////
	return RetState;
}


////////////////////////////////////////////////////////////////////////////////

// t@C݂邩ǂmF
BOOL  FileExists(LPCSTR PathName)
{
	DWORD  FileAttr = GetFileAttributes(PathName);
	if(FileAttr == (DWORD)-1)
		return FALSE;
	return (FileAttr & FILE_ATTRIBUTE_DIRECTORY) == 0;
}


////////////////////////////////////////////////////////////////////////////////

// fBNg݂邩ǂmF
BOOL  DirectoryExists(LPCSTR PathName)
{
	DWORD  FileAttr = GetFileAttributes(PathName);
	if(FileAttr == (DWORD)-1)
		return FALSE;
	return (FileAttr & FILE_ATTRIBUTE_DIRECTORY) != 0;
}


////////////////////////////////////////////////////////////////////////////////

// t@C܂̓fBNg݂邩ǂmF
BOOL  PathExists(LPCSTR PathName)
{
	return GetFileAttributes(PathName) != (DWORD)-1;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
