/*********************************************************************
 * cTetaPad.cpp
 *     TeraPad Oc[pCu
 * Originator
 *     Guni^2
 * Author
 *     "ĂƁ" <tategoto@harpy.org>
 * Updated
 *     2002/02/06
 *********************************************************************/


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// wb_[CN[h ////////////

#include  "cTeraPad.h"
#include  "clsVer.h"
#include  "WinUtil.h"

#include  <Lmcons.h>  // for GetUserName() API


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// 萔` ////////////

#define  MAX_GETTEXT_SIZE                         32760  // WM_GETTEXT Ŏ擾őeLXg
#define  BUF_SIZE                                  4096  // ʓIȍƂɎgobt@̃TCY

#define  MSECOND_WAIT_FOR_TERAPAD                    50  // TeraPad ̋N҂C^[o (~b)
#define  MSECOND_WAIT_FOR_TERAPAD_MAX              2500  // TeraPad ̋N҂ (~b)

#define  TERAPAD_MAP_PREFIX              "TeraPad_Map_"  // TeraPad eLXg󂯓ñ}bsOt@CIuWFNg̖ÕvtBNX

#define  TERAPAD_DEFAULT_EXENAME         "TeraPad.exe"   // ftHg TeraPad ̎st@C
#define  TERAPAD_DEFAULT_ININAME         "TeraPad.ini"   // ftHg TeraPad  INI t@C
#define  TERAPAD_DEFAULT_USRININAME      "usr.ini"       // ftHg̃[U[ݒ INI t@C
#define  TERAPAD_DEFAULT_USRTXTNAME      "usr.txt"       // ftHg̃[U[ݒ TXT t@C

#define  TERAPAD_USEINI_SECTION_INI      "INI"           // [U[ݒt@C INI t@CݒuꏊɊւZNV̖O
#define  TERAPAD_USEINI_KEY_USERINI      "UserIni"       // [U[ݒt@C̍ - 0 Ȃst@CƓtH_́A1 Ȃ烆[U[ʂ̃tH_ INI  KWD gp
#define  TERAPAD_USEINI_DEFAULT_USERINI               1  // [U[ݒt@C̍ڂ̋Kl - 1 ([U[ʂ̃tH_ INI  KWD gp)

#define  TERAPAD_PATH_USERS              "usr"           // [U[ʃtH_̃tH_

#define  CLASS_HSP_MAINWINDOW            "oniwnd0"       // HSP EBhẼNX


//////////// }N֐` ////////////

// BYTE ^ŁAvalue  from  to ̊Ԃ̒lłΐ^AłȂ΋U
#define  BYTE_BETWEEN(from, value, to)  ((BYTE)(from) <= (BYTE)(value) && (BYTE)(value) <= (BYTE)(to))

// LPSTR ^̐擪 2 oCgłΐ^AłȂ΋U
#define  IS_ZENCHAR(s)                  (                                                                                  \
											(BYTE_BETWEEN('\x81', (s)[0], '\x9F') || BYTE_BETWEEN('\xE0', (s)[0], '\xFC')) \
											&&                                                                             \
											(BYTE_BETWEEN('\x40', (s)[1], '\xFC') && (BYTE)((s)[1]) != (BYTE)0x7F)         \
										)

//////////// Tu[`vg^Cv` ////////////

template<class _C>  void  Swap(_C Value1, _C Value2);  // 2 ̓^̕ϐ̒lւ


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// RXgN^ / fXgN^ ////////////

// RXgN^
cls_TeraPad::cls_TeraPad()
{
	// őOʂ TeraPad ̃EBhEnh擾
	HWND  hWnd = NULL;
	for(int  i = 0; i < MSECOND_WAIT_FOR_TERAPAD_MAX; i += MSECOND_WAIT_FOR_TERAPAD)
	{
		// őOʂ̃EBhEnh擾
		hWnd = GetForegroundWindow();
		char  ClassBuf[MAX_PATH];
		ZeroMemory(ClassBuf, sizeof(ClassBuf));
		GetClassName(hWnd, ClassBuf, sizeof(ClassBuf));
		if(!strcmp(ClassBuf, TERAPAD_CLASS_MAINFORM))
			break;
		// 擾̂ HSP ̃AvP[VAłANeBu TeraPad T
		if(!strcmp(ClassBuf, CLASS_HSP_MAINWINDOW))
		{
			hWnd = FindWindow(TERAPAD_CLASS_MAINFORM, NULL);
			break;
		}
		hWnd = NULL;
		Sleep(MSECOND_WAIT_FOR_TERAPAD);
	}
	// NX̏
	Initialize(hWnd);
}


////////////////////////////////////////////////////////////////////////////////

// EBhEnhw̃RXgN^
cls_TeraPad::cls_TeraPad(HWND hWnd)
{
	// NX̏
	Initialize(hWnd);
}


////////////////////////////////////////////////////////////////////////////////

// NX̏
void  cls_TeraPad::Initialize(HWND hWnd)
{
	// NẌ̃NA
	hHeap = NULL;
	Destroy();

	InInitializing = true;

	// NULL Ԃ
	if(hWnd == NULL)
		return;

	// Ɨ̈ (q[v) 쐬 - sP
	hHeap = HeapCreate(NULL, NULL, NULL);
	if(hHeap == NULL)
		return;

	// ҏẄ悪oオ̂҂ - Ԑ؂ɂȂP
	int  i;
	for(i = 0; i < MSECOND_WAIT_FOR_TERAPAD_MAX; i += MSECOND_WAIT_FOR_TERAPAD)
	{
		if((hEdit = FindWindowEx(hWnd, NULL, TERAPAD_CLASS_EDITOR, NULL)) != NULL)
			break;
		Sleep(MSECOND_WAIT_FOR_TERAPAD);
	}
	if(hEdit == NULL)
	{
		Destroy();
		return;
	}

	// ^[Qbg TeraPad ̃EBhEnhݒ
	hWin = hWnd;

	// ҏW̃t@C̃pX擾
	hEdit = hEditSub = FindWindowEx(hWin, NULL, TERAPAD_CLASS_PATH, NULL);
	Path  = GetText();
	if(!Path)
		Path = "";

	// TeraPad ̎st@C̃pX擾
	hEdit = hEditSub = FindWindowEx(hWin, NULL, TERAPAD_CLASS_EXEPATH, NULL);
	if(hEdit != NULL)
		TpPath = GetText();
	else
	{
		TpPath = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, MAX_PATH + 2);
		if(TpPath == NULL)
			TpPath = TERAPAD_DEFAULT_EXENAME;
		else if(!GetWindowModuleName(hWin, TpPath, MAX_PATH + 2))
			lstrcpy(TpPath, TERAPAD_DEFAULT_EXENAME);
	}

	// TeraPad  INI t@C̃pX擾
	// TeraPad 0.7210 ȍ~
	hEdit   = hEditSub = FindWindowEx(hWin, NULL, TERAPAD_CLASS_INIPATH, NULL);
	IniPath = GetText();
	if(!IniPath || !IniPath[0])
	{
		bool  UserIniFileGotten = false;
		// st@C̖OƃoXɕ
		char   BasePath[MAX_PATH];
		char   ExeName[MAX_PATH];
		LPSTR  NextOfYen = BasePath;
		lstrcpy(BasePath, TpPath);
		for(i = 0; BasePath[i] != '\0'; i++)
		{
			if(IS_ZENCHAR(&BasePath[i]))
				i++;
			else if(BasePath[i] == '\\')
				NextOfYen = &BasePath[i + 1];
		}
		lstrcpy(ExeName, NextOfYen);
		*NextOfYen = '\0';
		// st@C̊gq ini ɕς
		size_t  NameLen = lstrlen(ExeName);
		lstrcpy(&ExeName[NameLen > 4 ? NameLen - 4: 0], ".ini");
		// [U[ݒt@Cݒǂݍ
		char  UsrIniFile[MAX_PATH];
		wsprintf(UsrIniFile, "%s" TERAPAD_DEFAULT_USRININAME, BasePath);
		if(GetPrivateProfileInt(TERAPAD_USEINI_SECTION_INI, TERAPAD_USEINI_KEY_USERINI, TERAPAD_USEINI_DEFAULT_USERINI, UsrIniFile) == 1)
		{
			// TeraPad 0.729 ȑO
			// st@C̏ꏊȉ usr\username\ ɂ INI t@C
			char   CurrentUser[UNLEN + 1];
			DWORD  dwCurrentUserSize = sizeof(CurrentUser);
			ZeroMemory(CurrentUser, dwCurrentUserSize);
			GetUserName(CurrentUser, &dwCurrentUserSize);
			if(CurrentUser[0])
			{
				wsprintf(&UsrIniFile[lstrlen(BasePath)], TERAPAD_PATH_USERS "\\%s\\%s" , CurrentUser, ExeName);
				IniPath = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, lstrlen(UsrIniFile) + 5);
				if(IniPath != NULL)
				{
					lstrcpy(IniPath, UsrIniFile);
					if(FileExists(IniPath))
						UserIniFileGotten = true;
					else
					{
						wsprintf(UsrIniFile, "%s" TERAPAD_DEFAULT_USRTXTNAME, BasePath);
						if(FileExists(UsrIniFile))
							UserIniFileGotten = true;
						else
							HeapFree(hHeap, NULL, IniPath);
					}
				}
			}
		}
		if(!UserIniFileGotten)
		{
			// TeraPad 0.727 ȑO
			// st@CƓO INI t@C
			strcat(BasePath, ExeName);
			IniPath = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, lstrlen(BasePath) + 5);
			if(IniPath == NULL)
				IniPath = TERAPAD_DEFAULT_ININAME;
			else
				lstrcpy(IniPath, BasePath);
		}
	}

	// ^[Qbg TeraPad  o[Wԍ (4 bytes ̏ォ珇 MajorAMinorAIsOfficialABetaNoB0.7210 Ȃ 0x0048000AA0.72 łȂ 0x00480100)
	// TeraPad 0.623 ȍ~
	cls_GetVersion  GetVersion(TpPath);
	LPSTR  FileVersion = GetVersion.Get(InfoKey_FileVersion);
	if(FileVersion)
	{
		LPSTR  Major      = FileVersion;
		LPSTR  Minor      = strchr(Major      + 1, '.'); if(!Minor     ) Minor      = "0"; else Minor++     ;
		LPSTR  IsOfficial = strchr(Minor      + 1, '.'); if(!IsOfficial) IsOfficial = "0"; else IsOfficial++;
		LPSTR  BetaNo     = strchr(IsOfficial + 1, '.'); if(!BetaNo    ) BetaNo     = "0"; else BetaNo++    ;
		Version = MakeTeraPadVersion(atoi(Major), atoi(Minor), atoi(IsOfficial), atoi(BetaNo));
	}
	else
	{
		// o[W擾łȂꍇ TeraPad 0.000 Ƃ݂Ȃ
		Version = MakeTeraPadVersion(0, 0, 0, 0);
	}

	// ҏẄ̃nh擾
	hEditUpper = FindWindowEx(hWin, NULL      , TERAPAD_CLASS_EDITOR, NULL);
	hEditLower = FindWindowEx(hWin, hEditUpper, TERAPAD_CLASS_EDITOR, NULL);

	// ANeBuȕҏẄ
	if(!GetSplit())
		hEdit = hEditSub = hEditLower = hEditUpper;
	else
	{
		hEdit = (HWND)SendMessage(hWin, TERAPAD_WM_GETACTIVEEDIT, NULL, NULL);
		if(hEdit == hEditLower)
			hEditSub = hEditUpper;
		else
		{
			hEdit    = hEditUpper;
			hEditSub = hEditLower;
		}
	}

	// ߑɕ\Ăŏ̍sԍ擾
	NowLineTop = SendMessage(hEdit, EM_GETFIRSTVISIBLELINE, NULL, NULL);
	// ߑɃJ[\̂s̔ԍ
	NowLine    = GetLine();
	// ߑɑIĂeLXg̊Jnʒu
	NowSelPos  = GetSelStart();
	// ߑɑIĂeLXg̒
	NowSelLen  = GetSelLength();

	// ANeBuҏWʂ̕ߑɕ\Ăŏ̍sԍ
	NowLineTopSub = SendMessage(hEditSub, EM_GETFIRSTVISIBLELINE, NULL, NULL);
	// ANeBuҏWʂ̕ߑɃJ[\̂s̔ԍ
	NowLineSub    = GetLine(true);
	// ANeBuҏWʂ̕ߑɑIĂeLXg̊Jnʒu
	NowSelPosSub  = GetSelStart(true);
	// ANeBuҏWʂ̕ߑɑIĂeLXg̒
	NowSelLenSub  = GetSelLength(true);

	InInitializing = false;
}


////////////////////////////////////////////////////////////////////////////////

// fXgN^
cls_TeraPad::~cls_TeraPad()
{
	Destroy();
}

////////////////////////////////////////////////////////////////////////////////

// NX̌n
void  cls_TeraPad::Destroy()
{
	// Ɨ̈iq[vjp
	if(hHeap != NULL)
		HeapDestroy(hHeap);
	// NẌ̃NA
	ZeroMemory(this, sizeof(cls_TeraPad));
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// J\bh ////////////

// NX̃CX^XɏĂ trueAłȂ false
bool  cls_TeraPad::operator!()
{
	return hEdit == NULL;
}


////////////////////////////////////////////////////////////////////////////////

// ^[Qbg TeraPad I
void  cls_TeraPad::Quit()
{
	// uEBhEjv R}h̑M
	SendMessage(hWin, WM_DESTROY, NULL, NULL);
	// uIv R}h̑M
	PostMessage(hWin, WM_QUIT,    NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// ^[Qbg TeraPad I - t@CۑĂȂꍇ̋ TeraPad C
void  cls_TeraPad::Close()
{
	// ^[Qbg TeraPad ANeBuɂ
	SetForegroundWindowSure(hWin);
	// uv R}h̑M
	SendMessage(hWin, WM_CLOSE, NULL, NULL);
}

////////////////////////////////////////////////////////////////////////////////

// ^[Qbg TeraPad ̓EBhEŃt@CJ
// TeraPad 0.622 ȍ~
void  cls_TeraPad::Load(LPCSTR NewFile)
{
	// Ag[Nh TeraPad ̃o[W`FbNAΉȂP
	if(Version < MakeTeraPadVersion(0, 62, 0, 2))
		return;
	// t@CAg
	ATOM  Atom = GlobalAddAtom(NewFile);
	if(Atom)
		// TeraPad ̃I[vbZ[WnhĂяo
	    SendMessage(hWin, TERAPAD_WM_LOADFILE, NULL, (LPARAM)Atom);
}


////////////////////////////////////////////////////////////////////////////////

// ㏑ۑ - VKt@C̏ꍇ͉NȂ
// TeraPad 0.6013 ȍ~
void  cls_TeraPad::Overwrite()
{
	// TeraPad ̏㏑ۑbZ[WnhĂяo
	SendMessage(hWin, TERAPAD_WM_SAVEFILE, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// ㏑ۑ - VKt@C̏ꍇ͖Otĕۑ_CAO\
void  cls_TeraPad::Save()
{
	// uCtrl + Sv L[̑M
	KeyDownWindow(hWin, VK_CONTROL);
	KeyPressWindow(hWin, 'S');
	KeyUpWindow(hWin, VK_CONTROL);
}


////////////////////////////////////////////////////////////////////////////////

// Otĕۑ_CAO\
void  cls_TeraPad::SaveAs()
{
	// uAlt + F + Av L[𑗐M
	KeyDownWindow(hWin, VK_MENU);
	KeyPressWindow(hWin, 'F');
	KeyPressWindow(hWin, 'A');
	KeyUpWindow(hWin, VK_MENU);

	// Vȃt@CoX擾
	HWND  hBakEdit    = hEdit;
	HWND  hEBakditSub = hEditSub;

	hEdit = hEditSub = FindWindowEx(hWin, NULL, TERAPAD_CLASS_PATH, NULL);
	Path  = GetText();
	if(!Path)
		Path = "";

	hEdit    = hBakEdit;
	hEditSub = hEBakditSub;
}


////////////////////////////////////////////////////////////////////////////////

// ݒ INI t@C̓e𔽉f
void  cls_TeraPad::ReloadIni()
{
	SendMessage(hWin, TERAPAD_WM_READINI, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// fBNgw肵ŁAݒ INI t@C̓e𔽉f
// TeraPad 0.7213 ȍ~
void  cls_TeraPad::ReloadIni(LPCSTR IniDir)
{
	// Ag[Nh TeraPad ̃o[W`FbNAΉȂP
	if(Version < MakeTeraPadVersion(0, 72, 0, 13))
		return;
	// fBNgAg
	ATOM  Atom = GlobalAddAtom(IniDir);
	if(Atom)
		// TeraPad ̐ݒ INI t@CefbZ[WnhĂяo
	    SendMessage(hWin, TERAPAD_WM_SETINIDIR, NULL, (LPARAM)Atom);
}


////////////////////////////////////////////////////////////////////////////////

// ҏW[h𒲂ׂ
en_TpEditMode  cls_TeraPad::GetEditMode()
{
	// TeraPad0.7014 ȑO
	if(Version < MakeTeraPadVersion(0, 72, 0, 15))
		return TpEditMode_Normal;
	// TeraPad0.7015 ȍ~
	int  EditMode = SendMessage(hWin, TERAPAD_WM_GETEDITMODE, NULL, NULL);
	switch(EditMode)
	{
		case TpSelMode_None:    // I
		case TpSelMode_Normal:  // ʏI
		case TpSelMode_Box:     // Z`I
			return (en_TpEditMode)EditMode;
	}
	return TpEditMode_Unknown;
}


////////////////////////////////////////////////////////////////////////////////

// ҏW[h𒲂ׁAɑ镶Ԃ
LPCSTR  cls_TeraPad::GetEditModeName()
{
	return GetEditModeName(GetEditMode());
}


////////////////////////////////////////////////////////////////////////////////

// ҏW[hlɑ镶Ԃ
LPCSTR  cls_TeraPad::GetEditModeName(en_TpEditMode EditMode)
{
	switch(EditMode)
	{
		case TpEditMode_Normal: return "W";
		case TpEditMode_HTML  : return "HTML";
		case TpEditMode_Perl  : return "Perl";
		case TpEditMode_INI   : return "INI";
		case TpEditMode_BAT   : return "BAT";
		case TpEditMode_CPP   : return "C/C++";
		case TpEditMode_Java  : return "Java";
		case TpEditMode_VB    : return "VB";
		case TpEditMode_HSP   : return "HSP";
		case TpEditMode_Delphi: return "Delphi";
	}
	return "(m̕ҏW[h)";
}

////////////////////////////////////////////////////////////////////////////////

// ҏW[hύX
void  cls_TeraPad::SetEditMode(en_TpEditMode EditMode)
{
	// ҏW[hɑΉANZ[^L[̑I
	char  AcceleratorKey;
	switch(EditMode)
	{
		case TpEditMode_Normal: AcceleratorKey = 'N'; break;
		case TpEditMode_HTML  : AcceleratorKey = 'H'; break;
		case TpEditMode_Perl  : AcceleratorKey = 'P'; break;
		case TpEditMode_INI   : AcceleratorKey = 'I'; break;
		case TpEditMode_BAT   : AcceleratorKey = 'B'; break;
		case TpEditMode_CPP   : AcceleratorKey = 'C'; break;
		case TpEditMode_Java  : AcceleratorKey = 'J'; break;
		case TpEditMode_VB    : AcceleratorKey = 'V'; break;
		case TpEditMode_HSP   : AcceleratorKey = 'S'; break;
		case TpEditMode_Delphi: AcceleratorKey = 'D'; break;
		default: return;
	}
	// ҏW[h̕ύX̂߂̃L[M
	KeyDownWindow(hWin, VK_MENU);
	KeyPressWindow(hWin, 'V');
	KeyPressWindow(hWin, 'M');
	KeyPressWindow(hWin, AcceleratorKey);
	KeyUpWindow(hWin, VK_MENU);
}


////////////////////////////////////////////////////////////////////////////////

// eLXgIԂ擾
// TeraPad 0.726 ȍ~
en_TpSelMode  cls_TeraPad::GetSelMode()
{
	// TeraPad0.705 ȑO
	if(Version < MakeTeraPadVersion(0, 72, 0, 6))
	{
		if(GetSelLength())
			return TpSelMode_Normal;
		return TpSelMode_None;
	}
	// TeraPad0.706 ȍ~
	int  SelMode = SendMessage(hWin, TERAPAD_WM_GETSELMODE, NULL, NULL);
	switch(SelMode)
	{
		case TpSelMode_None:    // I
		case TpSelMode_Normal:  // ʏI
		case TpSelMode_Box:     // Z`I
			return (en_TpSelMode)SelMode;
	}
	return TpSelMode_Unknown;
}


////////////////////////////////////////////////////////////////////////////////

// eLXgIԂ𒲂ׁAɑ镶Ԃ
LPCSTR  cls_TeraPad::GetSelModeName()
{
	return GetSelModeName(GetSelMode());
}


////////////////////////////////////////////////////////////////////////////////

// eLXgIԒlɑ镶Ԃ
LPCSTR  cls_TeraPad::GetSelModeName(en_TpSelMode SelMode)
{
	switch(SelMode)
	{
		case TpSelMode_None  : return "I";
		case TpSelMode_Normal: return "ʏI";
		case TpSelMode_Box   : return "Z`I";
	}
	return "(m̑I)";
}


////////////////////////////////////////////////////////////////////////////////

// ҏWʂĂ邩ǂ擾
bool  cls_TeraPad::GetSplit()
{
	return hEdit != hEditSub;
}


////////////////////////////////////////////////////////////////////////////////

// ҏWʂ𕪊邩ǂw
void  cls_TeraPad::SetSplit(bool Split)
{
	if(GetSplit() != Split)
	{
		// uCtrl + F5v 𑗐Mĕ[h؂ւ
		KeyDownWindow(hWin, VK_CONTROL);
		KeyPressWindow(hWin, VK_F5);
		KeyUpWindow(hWin, VK_CONTROL);
		// oϐ̍ď
		HWND  hWinBack = hWin;
		Initialize(hWinBack);
	}
}


////////////////////////////////////////////////////////////////////////////////

// ҏWʂĂꍇAANeBuȕҏWʂシ
void  cls_TeraPad::ReverseActiveEdit()
{
	if(GetSplit())
	{
		// ANeBu̕ҏWʂANeBuɂ
		SetActiveWindowSure(hEditSub);
		// oϐ̓ւ
		Swap(hEdit,      hEditSub);
		Swap(NowLineTop, NowLineTopSub);
		Swap(NowLine,    NowLineSub);
		Swap(NowSelPos,  NowSelPosSub);
		Swap(NowSelLen,  NowSelLenSub);
	}
}


////////////////////////////////////////////////////////////////////////////////

// ҏWʂĂꍇAANeBuȕҏWʂw肷 (true Ȃ㕔Afalse Ȃ牺)
void  cls_TeraPad::SetActiveEdit(bool ActiveUpper)
{
	if(GetSplit() && ((ActiveUpper && hEdit == hEditLower) || (!ActiveUpper && hEdit == hEditUpper)))
		ReverseActiveEdit();
}


////////////////////////////////////////////////////////////////////////////////

// Xe[^Xo[ɃbZ[Wݒ肷
// TeraPad 0.709 ȍ~
void  cls_TeraPad::SetStatusBar(LPCSTR sText)
{
	// Ag[Nh TeraPad ̃o[W`FbNAΉȂP
	if(Version < MakeTeraPadVersion(0, 70, 0, 9))
		return;
	// Ag
	ATOM  Atom = GlobalAddAtom(sText);
	if(Atom)
		// TeraPad ̃Xe[^Xo[ݒ胁bZ[WnhĂяo
	    SendMessage(hWin, TERAPAD_WM_SETSBHINTSTR, NULL, (LPARAM)Atom);
}


////////////////////////////////////////////////////////////////////////////////

// ҏWeLXgS
void  cls_TeraPad::Clear()
{
	SendMessage(hEdit, WM_CLEAR, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// IeLXgNbv{[hɐ؂
void  cls_TeraPad::Cut(bool SubWin)
{
	SendMessage(SubWin? hEditSub: hEdit, WM_CUT, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// IeLXgNbv{[hɃRs[
void  cls_TeraPad::Copy(bool SubWin)
{
	SendMessage(SubWin? hEditSub: hEdit, WM_COPY, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// IeLXgNbv{[h̓eŒu
void  cls_TeraPad::Paste(bool SubWin)
{
	SendMessage(SubWin? hEditSub: hEdit, WM_PASTE, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// Ȏ 1 蒼
void  cls_TeraPad::Undo(bool SubWin)
{
	SendMessage(SubWin? hEditSub: hEdit, EM_UNDO, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// IeLXgw蕶Œu
void  cls_TeraPad::Replace(LPCSTR sText, bool SubWin)
{
	SendMessage(SubWin? hEditSub: hEdit, EM_REPLACESEL, 0, (LPARAM)sText);
}


////////////////////////////////////////////////////////////////////////////////

// J[\̂s̔ԍ擾
DWORD  cls_TeraPad::GetLine(bool SubWin)
{
	return SendMessage(SubWin? hEditSub: hEdit, EM_LINEFROMCHAR, (WPARAM)-1, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// ws̐擪ɃJ[\Zbg
void  cls_TeraPad::SetLine(DWORD dwLine, bool SubWin)
{
	HWND  hWnd = SubWin? hEditSub: hEdit;

	if(dwLine == (DWORD)-1)
	{
		// ړbZ[WnhĂяo
		SendMessage(hWin, TERAPAD_WM_ENDJUNP, TRUE, NULL);
		// uPageDownv L[𑗐MĂɉɃXN[Aȍ~̋󔒕\ꂽԂɂ
		KeyPressWindow(hWnd, VK_NEXT);
		// ̉ʈʒuփXN[A̍sʒuփJ[\Zbg
		// TERAPAD_WM_ROWJUNP ͎wsʒɗĂ܂̂ŎgȂ
		SetSelStart(SendMessage(hWnd, EM_LINEINDEX, NowLineTop, NULL), SubWin);
		SetSelStart(SendMessage(hWnd, EM_LINEINDEX, NowLine,    NULL), SubWin);
	}
	else
		// wsփJ[\Zbg
		// ł͎wsʒɗŝ TERAPAD_WM_ROWJUNP g
		SendMessage(hWin, TERAPAD_WM_ROWJUNP, dwLine + 1, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// wsI (-1 ̏ꍇ͑ŜI)
void  cls_TeraPad::Select(DWORD dwLine, bool SubWin)
{
	HWND   hWnd = SubWin? hEditSub: hEdit;
	DWORD  dwStart;
	DWORD  dwEnd;

	if(dwLine == (DWORD)-1)  // ׂđI
	{
		// IJnʒúAeLXgŜ̍Ő[
		dwStart = 0;
		// IIʒúAeLXgŜ̍Ŗ[
		dwEnd   = (DWORD)-1;
	}
	else  // sI
	{
		// IJnʒúAws̐擪
		dwStart = SendMessage(hWnd, EM_LINEINDEX, (WPARAM)dwLine, NULL);
		if(dwStart == (DWORD)-1)
			dwStart = dwEnd = Length();
		else
		{
			// IJnʒúAws̎̍s擪 1 O
			dwEnd = SendMessage(hWnd, EM_LINEINDEX, (WPARAM)(dwLine + 1), NULL);
			if(dwEnd == (DWORD)-1)
				dwEnd = Length();
		}
	}

	// Iʒu̐ݒ
	SendMessage(hWnd, EM_SETSEL, dwStart, dwEnd);
}


////////////////////////////////////////////////////////////////////////////////

// IeLXg̊Jnʒu擾
DWORD  cls_TeraPad::GetSelStart(bool SubWin)
{
	DWORD  dwSel;
	SendMessage(SubWin? hEditSub: hEdit, EM_GETSEL, (WPARAM)&dwSel, NULL);
	return dwSel;
}


////////////////////////////////////////////////////////////////////////////////

// IeLXg̊Jnʒuݒ肷
void  cls_TeraPad::SetSelStart(DWORD dwSel, bool SubWin)
{
	SendMessage(SubWin? hEditSub: hEdit, EM_SETSEL, dwSel, dwSel);
}


////////////////////////////////////////////////////////////////////////////////

// IeLXg̃TCY擾
DWORD  cls_TeraPad::GetSelLength(bool SubWin)
{
	DWORD  dwSelStart;
	DWORD  dwSelEnd;
	SendMessage(SubWin? hEditSub: hEdit, EM_GETSEL, (WPARAM)&dwSelStart, (LPARAM)&dwSelEnd);
	return dwSelEnd - dwSelStart;
}


////////////////////////////////////////////////////////////////////////////////

// IeLXg̃TCYݒ肷
void  cls_TeraPad::SetSelLength(DWORD dwSel, bool SubWin)
{
	DWORD  dwSelStart = GetSelStart(SubWin);
	SendMessage(SubWin? hEditSub: hEdit, EM_SETSEL, dwSelStart, (LPARAM)(dwSelStart + dwSel));
}


////////////////////////////////////////////////////////////////////////////////

// ҏWeLXg̑STCY擾
DWORD  cls_TeraPad::Length()
{
	return SendMessage(hEdit, WM_GETTEXTLENGTH, NULL, NULL);
}


////////////////////////////////////////////////////////////////////////////////

// ҏWeLXgS擾
LPSTR  cls_TeraPad::GetText()
{
	// Ƃ肠}bvgt@CoRł̓]Ă݂
	LPSTR  sText = NULL;
	if(TransferText(false, sText, TERAPAD_TEXT_ALL))
		return sText;

	// EChEbZ[WoRŎ擾
	// Iʒu擾
	DWORD  dwStart    = GetSelStart();
	DWORD  dwLen      = GetSelLength();
	// eLXg̒擾
	DWORD  dwTotalLen = Length();
	DWORD  dwCopyLen  = dwTotalLen;
	if(dwCopyLen > MAX_GETTEXT_SIZE)
		dwCopyLen = MAX_GETTEXT_SIZE;
	//obt@̍쐬
	sText = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, dwTotalLen + 1);
	if(sText == NULL) return NULL;
	// eLXg{̂Ƃ̒擾
	dwCopyLen = SendMessage(hEditSub, WM_GETTEXT, dwCopyLen + 1, (LPARAM)sText);
	//擾eLXg̃oCgƂāAĎ擾
	DWORD  dwUndoCnt = 0;   // Undo 񐔃JE^
	DWORD  dwTotalCopyLen;
	for(dwTotalCopyLen = dwCopyLen; dwTotalCopyLen < dwTotalLen && dwCopyLen > 0; dwTotalCopyLen += dwCopyLen)
	{
		// 擾ς݃eLXgNA
		SendMessage(hEditSub, EM_SETSEL, 0, dwCopyLen);  
		Clear();
		// ŃNA Undo 邽߂̃JE^
		dwUndoCnt++;
		// ̃eLXg擾
		if(dwCopyLen + dwTotalCopyLen > dwTotalLen)
			dwCopyLen = dwTotalLen - dwTotalCopyLen;
		dwCopyLen = SendMessage(hEditSub, WM_GETTEXT, dwCopyLen + 1, (LPARAM)&sText[dwTotalCopyLen]);
	}
	// I[}[J[ݒu
	sText[dwTotalCopyLen] = '\0';
	// ꍇ̏
	if(dwUndoCnt)
	{
		// 񐔕 Undo ɖ߂iƂBj
		for(DWORD  dwLoop = 0; dwLoop < dwUndoCnt; dwLoop++)
			Undo(true);
		// I͈͂ɖ߂
		if(!GetSplit())
			SendMessage(hEditSub, EM_SETSEL, (WPARAM)dwStart, (LPARAM)(dwStart + dwLen));
	}
	// M
	return sText;
}


////////////////////////////////////////////////////////////////////////////////

// ҏWeLXgw蕶ɑSĒu
void  cls_TeraPad::SetText(LPCSTR sText)
{
	// Ƃ肠}bvgt@CoRł̓]Ă݂
	LPSTR  lpText = (LPSTR)sText;
	if(TransferText(true, lpText, TERAPAD_TEXT_ALL))
		return;

	// EChEbZ[WoRœ\t
	// \teLXg̒̎擾
	DWORD  dwTotalLen = lstrlen(sText);
	// \t
	Select((DWORD)-1, true);
	Replace(sText, true);
	// \tꂽeLXg̒擾
	DWORD  dwCopyLen = Length();
	// \tꂽeLXg̒ƂāAē\t
	for(DWORD  dwTotalCopyLen = dwCopyLen; dwTotalCopyLen < dwTotalLen && dwCopyLen > 0; dwTotalCopyLen += dwCopyLen)
	{
		// \t
		Replace(&sText[dwTotalCopyLen], true);
		// \tꂽeLXg̒擾
		dwCopyLen = Length() - dwTotalCopyLen;
	}
}


////////////////////////////////////////////////////////////////////////////////

// I͈͂̃eLXg擾
LPSTR  cls_TeraPad::GetSelText()
{
	// Ƃ肠}bvgt@CoRł̓]Ă݂
	LPSTR  sText = NULL;
	if(TransferText(false, sText, TERAPAD_TEXT_SEL))
		return sText;

	// EChEbZ[WoRŎ擾
	// Iʒu擾
	DWORD  dwStart  = GetSelStart();
	DWORD  dwLen    = GetSelLength();
	// eLXgŜ擾
	sText = GetText();
	if(sText == NULL)
	    return NULL;
	// I͈͂𔲂o
	MoveMemory(sText, &sText[dwStart], dwLen);
	sText[dwLen] = '\0';
	LPSTR  sSeltext = (LPSTR)HeapReAlloc(hHeap, HEAP_ZERO_MEMORY, sText, dwLen + 1);
	if(sSeltext == NULL)
	    return sText;
	// M
	return sSeltext;
}


////////////////////////////////////////////////////////////////////////////////

// IeLXgw蕶ɒu
void  cls_TeraPad::SetSelText(LPCSTR sText)
{
	// Iʒu擾
	DWORD  dwStart = GetSelStart();
	DWORD  dwLen   = GetSelLength();
	// \teLXg̒̎擾
	DWORD  dwTotalLen  = lstrlen(sText);

	// Ƃ肠}bvgt@CoRł̓]Ă݂
	LPSTR  lpText = (LPSTR)sText;
	if(!TransferText(true, lpText, TERAPAD_TEXT_SEL))
	{
		// EChEbZ[WoRœ\t
		// uΏۊÕeLXg̗ʂ擾
		DWORD  dwOthersLen = Length() - dwLen;
		// \t
		Replace(sText);
		// \tꂽeLXg̒擾
		DWORD  dwCopyLen = Length() - dwOthersLen;
		// \tꂽeLXg̒ƂāAē\t
		for(DWORD  dwTotalCopyLen = dwCopyLen; dwTotalCopyLen < dwTotalLen && dwCopyLen > 0; dwTotalCopyLen += dwCopyLen)
		{
			// \t
			Replace(&sText[dwTotalCopyLen]);
			// \tꂽeLXg̒擾
			dwCopyLen = Length() - dwTotalCopyLen - dwOthersLen;
		}
	}
	// \teLXgI͈͂ɐݒ
	SendMessage(hEdit, EM_SETSEL, (WPARAM)dwStart, (LPARAM)(dwStart + dwTotalLen));
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// \bh ////////////

// }bvgt@Cgpă^[Qbg TeraPad ƃeLXg肷
// TeraPad 0.731 ȍ~
bool  cls_TeraPad::TransferText(bool Send, LPSTR &sText, DWORD CopyMode)
{
	//////////// }bvgt@Cgp\ǂ̊mF ////////////
	// NX̏̎sł邩A^[Qbg}bvgt@CΉ TeraPad ̏ꍇ͓P
	if(InInitializing || Version < MakeTeraPadVersion(0, 73, 0, 1))
		return false;

	//////////// }bvIuWFNg̐ ////////////
	// eLXg̒擾
	DWORD  dwLength;
	if(Send)
		dwLength = lstrlen(sText);
	else if(CopyMode == TERAPAD_TEXT_ALL)
		dwLength = Length();
	else
		dwLength = GetSelLength();
	// }bvIuWFNg쐬 - sP
	DWORD  dwBufSize = dwLength + 1;
	char   Buf[BUF_SIZE];
	wsprintf(Buf, "%s%u", TERAPAD_MAP_PREFIX, hWin);
	HANDLE  hMap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, dwBufSize + 256, Buf);
	if(!hMap)
		return false;

	//////////// }bvIuWFNg̓e̐ݒ ////////////
	// }bvIuWFNg݉\ȃ̈ɌŒ肷 - sP
	LPVOID  MemoryPos = NULL;
	if(Send)
	{
		LPVOID  MemoryPos = MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, 0);
		if(!MemoryPos)
		{
			CloseHandle(hMap);
			return false;
		}
		// ̈ݒ
		MoveMemory(MemoryPos, sText, dwBufSize);
		// }bvIuWFNg̈悩
		UnmapViewOfFile(MemoryPos);
	}

	//////////// }bvIuWFNggăeLXg] ////////////
	// eLXg] - sP
	if(!SendMessage(hWin, Send? TERAPAD_WM_SETTEXT: TERAPAD_WM_GETTEXT, CopyMode, Send? dwLength: NULL))
	{
		CloseHandle(hMap);
		return false;
	}
	// Set ̏ꍇ́AŏĂ̂łŊM
	if(Send)
	{
		CloseHandle(hMap);
		return true;
	}

	//////////// Get ̏ꍇ́A]ꂽeLXg擾 ////////////
	// 󂯂obt@̊m - sP
	sText = (LPSTR)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, dwBufSize);
	if(!sText)
	{
		CloseHandle(hMap);
		return false;
	}
	// }bvIuWFNgǂݍ݉\ȃ̈ɌŒ肷 - sP
	MemoryPos = MapViewOfFile(hMap, FILE_MAP_READ, 0, 0, 0);
	if(!MemoryPos)
	{
		HeapFree(hHeap, NULL, sText);
		CloseHandle(hMap);
		return false;
	}
	// eLXg擾
	MoveMemory(sText, MemoryPos, dwLength);
	// }bvIuWFNg̈悩
	UnmapViewOfFile(MemoryPos);

	//////////// M ////////////
	CloseHandle(hMap);
	return true;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// Tu[`` ////////////

// 2 ̓^̕ϐ̒lւ
template<class _C>  void  Swap(_C Value1, _C Value2)
{
	_C  ValueS = Value1;
	Value1 = Value2;
	Value2 = ValueS;
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
